﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using SimpleJSON;

namespace CtxMenuPlugin
{
    public class ContextMenu: MVRScript
    {
        protected Dictionary<string, float> morphDict  = new Dictionary<string, float>();protected Dictionary<string, float> morphDict2 = new Dictionary<string, float>();protected Dictionary<string, float> morphDict3 = new Dictionary<string, float>();protected Dictionary<string, float> morphDict4 = new Dictionary<string, float>();protected Dictionary<string, float> morphDict5  = new Dictionary<string, float>();protected Dictionary<string, float> mergeDict  = new Dictionary<string, float>();protected Dictionary<string, float>    styleDict1  = new Dictionary<string, float>();protected Dictionary<string, HSVColor> colorDict1  = new Dictionary<string, HSVColor>();protected Dictionary<int, bool> clothDict     = new Dictionary<int, bool>();JSONStorableFloat morphDivider;
        protected JSONStorableBool useShortcuts; protected JSONStorableFloat randomHairLengthSlider;protected JSONStorableFloat randomHairCurlSlider;protected JSONStorableBool proportionalRandomization;protected JSONStorableFloat secondPanelShiftSlider;protected JSONStorableFloat newDNAMultiplierSlider;protected JSONStorableBool allowRandomHairColors;protected JSONStorableFloat newDNAminValueSlider;protected JSONStorableFloat newDNAValueSlider;protected JSONStorableFloat defPositionSlider;protected JSONStorableStringChooser lookMode;private   DAZCharacterSelector character_c;protected JSONStorableBool allowRandomHair;protected JSONStorableFloat defDistSlider;protected JSONStorableFloat alphaSlider;protected JSONStorableFloat hideDistSlider;protected JSONStorableFloat defautHeight;protected JSONStorableFloat randomSlider;protected JSONStorableFloat newDNASlider;protected JSONStorableBool randomizeSkc;protected JSONStorableString hairWidth;protected JSONStorableString morphList;protected JSONStorableFloat hairSlider;protected JSONStorableBool rainbowSkin;protected JSONStorableBool rainbowHair;protected JSONStorableBool rainbowEyes;protected JSONStorableBool randomHairSimStyle;protected JSONStorableBool randomSkinTexture; protected JSONStorableBool randomCurls;protected JSONStorableBool lowGPUhairs;protected JSONStorableBool hideMenu;protected JSONStorableFloat posAdjust;protected JSONStorableFloat mixSlider;protected JSONStorableBool clearSkin;protected JSONStorableBool mix1and2;protected JSONStorableBool qksv1;protected JSONStorableBool qksv2;protected JSONStorableFloat minEyeSlider;protected JSONStorableFloat maxEyeSlider;protected JSONStorableBool allowRandomSkin;protected JSONStorableBool randomScale;protected JSONStorableBool allowRandomEyes;protected JSONStorableFloat jDriveSpringSlider;protected JSONStorableFloat jDriveDamperSlider;public bool initOver = false;protected string choiceName;protected string[] hairs;protected string[] scalps;private bool hideMenuBcDist = false;string[] femaleHairs = {"HairSimPonyTail","HairSimLongStraight","HairSimLongStraightOpt","HairSimLongCurls","HairSimLongHalfShave","HairSimMediumBob","HairSimMediumStraightBangs","HairSimMediumBangsHeart","HairSimMediumBangsBob","HairSimShortBangs","HairSimShortWavyBangs","HairSimShortPixie","HairSimShortPixieBangs","HairSimMohawk","HairSimPixiehawk","HairSimBoyish","HairSimStraightFringe","HairSimSlickBack","HairSimAfro","HairSimMessy"};string[] maleHairs = {"HairSimMalePonyTail","HairSimMaleLongStraight","HairSimMaleLongCurls","HairSimMaleLongHalfShave","HairSimMaleMediumBob","HairSimMaleMediumStraightBangs","HairSimMaleMediumBangsHeart","HairSimMaleMediumBangsBob","HairSimMaleShortBangs","HairSimMaleShortWavyBangs","HairSimMaleShortPixie","HairSimMaleShortPixieBangs","HairSimMaleMohawk","HairSimMalePixiehawk","HairSimMaleBoyish","HairSimMaleStraightFringe","HairSimMaleSlickBack","HairSimMaleAfro","HairSimMaleMessy"};string[] femaleHairChoices = {"Ponytail","Long+Straight","Long+StraightOpt","Long+Curls","Long+HalfShave","Medium+Bob","Medium+Straight+Bangs","Medium+Bangs+Heart","Medium+Bangs+Bob","Short+Bangs","Short+Wavy+Bangs","Short+Pixie","Short+Pixie+Bangs","Mohawk","Pixiehawk","Boyish","StraightFringe","SlickBack","Afro","Messy"};
        string[] maleHairChoices = {"Ponytail","Long+Straight","Long+Curls","Long+HalfShave","Medium+Bob","Medium+Straight+Bangs","Medium+Bangs+Heart","Medium+Bangs+Bob","Short+Bangs","Short+Wavy+Bangs","Short+Pixie","Short+Pixie+Bangs","Mohawk","Pixiehawk","Boyish","StraightFringe","SlickBack","Afro","Messy"};
        protected Dictionary<string, string> femaleHairsDict = new Dictionary<string, string>();protected Dictionary<string, string> maleHairsDict   = new Dictionary<string, string>(); private JSONStorableBool randomName;
        string[] femaleScalps = {"Sim2HairMaterialScalpOmri","Sim2HairMaterialScalpKrayon","Sim2HairMaterialScalpUdane","Sim2HairMaterialScalpChace","Sim2HairMaterialScalpLeyton","Sim2HairMaterialScalpSoleil"};
        string[] maleScalps = {"Sim2HairMaterialScalpScott","Sim2HairMaterialScalpTyler"};List<Atom> buttons = new List<Atom>();int buttonIndex = 0;const float BUTTON_SPACINGY = .064f;const float BUTTON_SPACINGX = .5f;
        FreeControllerV3 lastSelected; protected JSONStorableBool vanillaDNA; private JSONStorableStringChooser regionChoices;string[] femaleNames = {"Emma","Olivia","Ava","Sophia","Isabella","Mia","Charlotte","Abigail","Emily","Harper","Amelia","Evelyn","Elizabeth","Sofia","Madison","Avery","Ella","Scarlett","Grace","Chloe","Victoria","Riley","Aria","Lily","Aubrey","Zoey","Penelope","Lillian","Addison","Layla","Natalie","Camila","Hannah","Brooklyn","Zoe","Nora","Leah","Savannah","Audrey","Claire","Eleanor","Skylar","Ellie","Samantha","Stella","Paisley","Violet","Mila","Allison","Alexa","Anna","Hazel","Aaliyah","Ariana","Lucy","Caroline","Sarah","Genesis","Kennedy","Sadie","Gabriella","Madelyn","Adeline","Maya","Autumn","Aurora","Piper","Hailey","Arianna","Kaylee","Ruby","Serenity","Eva","Naomi","Nevaeh","Alice","Luna","Bella","Quinn","Lydia","Peyton","Melanie","Kylie","Aubree","Mackenzie","Kinsley","Cora","Julia","Taylor","Katherine","Madeline","Gianna","Eliana","Elena","Vivian","Willow","Reagan","Brianna","Clara","Faith","Ashley","Emilia","Isabelle","Annabelle","Rylee","Valentina","Everly","Hadley","Sophie","Alexandra","Natalia","Ivy","Maria","Josephine","Delilah","Bailey","Jade","Ximena","Alexis","Alyssa","Brielle","Jasmine","Liliana","Adalynn","Khloe","Isla","Mary","Andrea","Kayla","Emery","London","Kimberly","Morgan","Lauren","Sydney","Nova","Trinity","Lyla","Margaret","Ariel","Adalyn","Athena","Lilly","Melody","Isabel","Jordyn","Jocelyn","Eden","Paige","Teagan","Valeria","Sara","Norah","Rose","Aliyah","Mckenzie","Molly","Raelynn","Leilani","Valerie","Emerson","Juliana","Nicole","Laila","Makayla","Elise","Mariah","Mya","Arya","Ryleigh","Adaline","Brooke","Rachel","Eliza","Angelina","Amy","Reese","Alina","Cecilia","Londyn","Gracie","Payton","Esther","Alaina","Charlie","Iris","Arabella","Genevieve","Finley","Daisy","Harmony","Anastasia","Kendall","Daniela","Catherine","Adelyn","Vanessa","Brooklynn","Juliette","Julianna","Presley","Summer","Destiny","Amaya","Hayden","Alana","Rebecca","Michelle","Eloise","Lila","Fiona","Callie","Lucia","Angela","Marley","Adriana","Parker","Alexandria","Giselle","Alivia","Alayna","Brynlee","Ana","Harley","Gabrielle","Dakota","Georgia","Juliet","Tessa","Leila","Kate","Jayla","Jessica","Lola","Stephanie","Sienna","Josie","Daleyza","Rowan","Evangeline","Hope","Maggie","Camille","Makenzie","Vivienne","Sawyer","Gemma","Joanna","Noelle","Elliana","Mckenna","Gabriela","Kinley","Rosalie","Brynn","Amiyah","Melissa","Adelaide","Malia","Ayla","Izabella","Delaney","Cali","Journey","Maci","Elaina","Sloane","June","Diana","Blakely","Aniyah","Olive","Jennifer","Paris","Miranda","Lena","Jacqueline","Paislee","Jane","Raegan","Lyric","Lilliana","Adelynn","Lucille","Selena","River","Annie","Cassidy","Jordan","Thea","Mariana","Amina","Miriam","Haven","Remi","Charlee","Blake","Lilah","Ruth","Amara","Kali","Kylee","Arielle","Emersyn","Alessandra","Fatima","Talia","Vera","Nina","Ariah","Allie","Addilyn","Keira","Catalina","Raelyn","Phoebe","Lexi","Zara","Makenna","Ember","Leia","Rylie","Angel","Haley","Madilyn","Kaitlyn","Heaven","Nyla","Amanda","Freya","Journee","Daniella","Danielle","Kenzie","Ariella","Lia","Brinley","Maddison","Shelby","Elsie","Kamila","Camilla","Alison","Ainsley","Ada","Laura","Kendra","Kayleigh","Adrianna","Madeleine","Joy","Juniper","Chelsea","Sage","Erin","Felicity","Gracelyn","Nadia","Skyler","Briella","Aspen","Myla","Heidi","Katie","Zuri","Jenna","Kyla","Kaia","Kira","Sabrina","Gracelynn","Gia","Amira","Alexia","Amber","Cadence","Esmeralda","Katelyn","Scarlet","Kamryn","Alicia","Miracle","Kelsey","Logan","Kiara","Bianca","Kaydence","Alondra","Evelynn","Christina","Lana","Aviana","Dahlia","Dylan","Anaya","Ashlyn","Jada","Kathryn","Jimena","Elle","Gwendolyn","April","Carmen","Mikayla","Annalise","Maeve","Camryn","Helen","Daphne","Braelynn","Carly","Cheyenne","Leslie","Veronica","Nylah","Kennedi","Skye","Evie","Averie","Harlow","Allyson","Carolina","Tatum","Francesca","Aylin","Ashlynn","Sierra","Mckinley","Leighton","Maliyah","Annabella","Megan","Margot","Luciana","Mallory","Millie","Regina","Nia","Rosemary","Saylor","Abby","Briana","Phoenix","Viviana","Alejandra","Frances","Jayleen","Serena","Lorelei","Zariah","Ariyah","Jazmin","Avianna","Carter","Marlee","Eve","Aleah","Remington","Amari","Bethany","Fernanda","Malaysia","Willa","Liana","Ryan","Addyson","Yaretzi","Colette","Macie","Selah","Nayeli","Madelynn","Michaela","Priscilla","Janelle","Samara","Justice","Itzel","Emely","Lennon","Aubrie","Julie","Kyleigh","Sarai","Braelyn","Alani","Lacey","Edith","Elisa","Macy","Marilyn","Baylee","Karina","Raven","Celeste","Adelina","Matilda","Kara","Jamie","Charleigh","Aisha","Kassidy","Hattie","Karen","Sylvia","Winter","Aleena","Angelica","Magnolia","Cataleya","Danna","Henley","Mabel","Kelly","Brylee","Jazlyn","Virginia","Helena","Jillian","Madilynn","Blair","Galilea","Kensley","Wren","Bristol","Emmalyn","Holly","Lauryn","Cameron","Hanna","Meredith","Royalty","Sasha","Lilith","Jazmine","Alayah","Madisyn","Cecelia","Renata","Lainey","Liberty","Brittany","Savanna","Imani","Kyra","Mira","Mariam","Tenley","Aitana","Gloria","Maryam","Giuliana","Skyla","Anne","Johanna","Myra","Charley","Tiffany","Beatrice","Karla","Cynthia","Janiyah","Melany","Alanna","Lilian","Demi","Pearl","Jaylah","Maia","Cassandra","Jolene","Crystal","Everleigh","Maisie","Anahi","Elianna","Hallie","Ivanna","Oakley","Ophelia","Emelia","Mae","Marie","Rebekah","Azalea","Haylee","Bailee","Anika","Monica","Kimber","Sloan","Jayda","Anya","Bridget","Kailey","Julissa","Marissa","Leona","Aileen","Addisyn","Kaliyah","Coraline","Dayana","Kaylie","Celine","Jaliyah","Elaine","Lillie","Melina","Jaelyn","Shiloh","Jemma","Madalyn","Addilynn","Alaia","Mikaela","Adley","Saige","Angie","Dallas","Braylee","Elsa","Emmy","Hayley","Siena","Lorelai","Miah","Royal","Tiana","Elliot","Kori","Greta","Charli","Elliott","Julieta","Alena","Rory","Harlee","Rosa","Ivory","Guadalupe","Jessie","Laurel","Annika","Clarissa","Karsyn","Collins","Kenia","Milani","Alia","Chanel","Dorothy","Armani","Emory","Ellen","Irene","Adele","Jaelynn","Myah","Hadassah","Jayde","Lilyana","Malaya","Kenna","Amelie","Reyna","Teresa","Angelique","Linda","Nathalie","Kora","Zahra","Aurelia","Kalani","Rayna","Jolie","Sutton","Aniya","Jessa","Laylah","Esme","Keyla","Ariya","Elisabeth","Marina","Mara","Meadow","Aliza","Zelda","Lea","Elyse","Monroe","Penny","Lilianna","Lylah","Liv","Scarlette","Kadence","Ansley","Emilee","Perla","Annabel","Alaya","Milena","Karter","Avah","Amirah","Leyla","Livia","Chaya","Wynter","Jaycee","Lailah","Amani","Milana","Lennox","Remy","Zariyah","Clare","Hadlee","Kiera","Rosie","Alma","Kaelyn","Eileen","Jayden","Martha","Noa","Christine","Ariadne","Natasha","Emerie","Tatiana","Joselyn","Joyce","Salma","Amiya","Audrina","Kinslee","Jaylene","Analia","Erika","Lexie","Mina","Patricia","Dulce","Poppy","Aubrielle","Clementine","Lara","Amaris","Milan","Aliana","Kailani","Kaylani","Maleah","Belen","Simone","Whitney","Elora","Claudia","Gwen","Rylan","Antonella","Khaleesi","Arely","Princess","Kenley","Itzayana","Karlee","Paulina","Laney","Bria","Chana","Kynlee","Astrid","Giovanna","Lindsey","Sky","Aryanna","Ayleen","Azariah","Joelle","Nala","Tori","Noemi","Breanna","Emmeline","Mavis","Amalia","Mercy","Tinley","Averi","Aiyana","Alyson","Corinne","Leanna","Madalynn","Briar","Jaylee","Kailyn","Kassandra","Kaylin","Nataly","Amia","Yareli","Cara","Taliyah","Thalia","Carolyn","Estrella","Montserrat","Zaylee","Anabelle","Deborah","Frida","Zaria","Kairi","Katalina","Nola","Erica","Isabela","Jazlynn","Paula","Faye","Louisa","Alessia","Courtney","Reign","Ryann","Stevie","Heavenly","Lisa","Roselyn","Raina","Adrienne","Celia","Estelle","Marianna","Brenda","Kathleen","Paola","Hunter","Ellis","Hana","Lina","Raquel","Aliya","Iliana","Kallie","Emmalynn","Naya","Reina","Wendy","Landry","Barbara","Casey","Karlie","Kiana","Rivka","Kenya","Aya","Carla","Dalary","Jaylynn","Sariah","Andi","Romina","Dana","Danica","Ingrid","Kehlani","Zaniyah","Alannah","Avalynn","Evalyn","Sandra","Veda","Hadleigh","Paityn","Abril","Ciara","Holland","Lillianna","Kai","Bryleigh","Emilie","Carlee","Judith","Kristina","Janessa","Annalee","Zoie","Maliah","Bonnie","Emmaline","Louise","Kaylynn","Monserrat","Nancy","Noor","Vada","Aubriella","Maxine","Nathalia","Tegan","Aranza","Emmie","Brenna","Estella","Ellianna","Kailee","Ailani","Caylee","Zainab","Zendaya","Jana","Julianne","Ellison","Sariyah","Lizbeth","Susan","Alyvia","Jewel","Marjorie","Marleigh","Nathaly","Sharon","Yamileth","Zion","Mariyah","Lyra","Belle","Yasmin","Kaiya","Maren","Marisol","Vienna","Calliope","Hailee","Rayne","Tabitha","Anabella","Blaire","Giana","Milania","Paloma","Amya","Novalee","Harleigh","Ramona","Rhea","Aadhya","Miya","Desiree","Frankie","Sylvie","Jasmin","Moriah","Rosalyn","Kaya","Joslyn","Tinsley","Farrah","Aislinn","Halle","Madyson","Micah","Arden","Bexley","Ari","Aubri","Ayana","Cherish","Davina","Anniston","Riya","Adilynn","Ally","Amayah","Harmoni","Heather","Saoirse","Azaria","Alisha","Nalani","Maylee","Shayla","Briley","Elin","Lilia","Ann","Antonia","Aryana","Chandler","Esperanza","Lilyanna","Alianna","Luz","Meilani"}; string[] lastNames = {"abbey","abram","acker","adair","adam","adams","adamson","addison","adkins","aiken","akerman","akers","albert","albertson","albinson","alexander","alfredson","alger","alvin","anderson","andrews","ansel","appleton","archer","armistead","arnold","arrington","arthur","arthurson","ashworth","atkins","atkinson","austin","avery","babcock","bagley","bailey","baker","baldwin","bancroft","banister","banks","banner","barber","barker","barlow","bass","bates","baxter","beake","beasley","beck","beckett","beckham","bell","bellamy","bennett","benson","bentley","benton","bernard","berry","beverley","bird","black","blackburn","bond","bonham","bourke","braddock","bradford","bradley","brand","brandon","breckenridge","brewer","brewster","brigham","bristol","brook","brooke","brown","bryson","buckley","bullard","bullock","burnham","burrell","burton","bush","byrd","cantrell","carl","carlisle","carlyle","carman","carpenter","carter","cartwright","carver","caulfield","causer","chadwick","chamberlain","chance","chandler","chapman","chase","cheshire","chlarke","church","clark","clarkson","clay","clayton","clemens","clifford","clifton","cline","clinton","close","coburn","coke","colbert","cole","coleman","colton","comstock","constable","cook","cooke","cookson","cooper","corey","cornell","courtney","cox","crawford","crewe","croft","cropper","cross","crouch","cummins","curtis","dalton","danell","daniel","darby","darrell","darwin","daubney","david","davidson","davies","davis","dawson","day","dean","deering","delaney","denman","dennel","dennell","derby","derrick","devin","devine","dickens","dickenson","dickinson","dickman","donalds","donaldson","downer","draper","dudley","duke","dunn","durand","durant","dustin","dwight","dyer","dyson","eason","easton","eaton","edgar","edison","edwards","edwarson","eliot","eliott","elliott","ellis","ellison","emerson","emmett","endicott","ericson","evanson","evelyn","everett","fairbarn","fairburn","fairchild","fay","fields","fisher","fleming","fletcher","ford","forest","forester","forrest","foss","foster","fox","frank","franklin","freeman","frost","fry","fuller","gardener","gardner","garfield","garland","garner","garnet","garrard","garrett","garry","geary","gibbs","gibson","gilbert","giles","gilliam","gladwin","glover","goddard","goode","goodwin","granger","grant","gray","green","greene","griffin","gully","hackett","hadaway","haden","haggard","haight","hailey","haley","hall","hallman","hamilton","hamm","hancock","hanley","hanson","hardy","harford","hargrave","harlan","harley","harlow","harman","harper","hart","harvey","hathaway","hawk","hawking","hawkins","hayes","haywood","heath","hedley","henderson","henry","henson","herbert","herman","hewitt","hibbert","hicks","hightower","hill","hilton","hobbes","hobbs","hobson","hodges","hodson","holmes","holt","hooker","hooper","hope","hopper","horn","horne","horton","house","howard","howe","hudson","hughes","hull","hume","hunt","hunter","hurst","huxley","huxtable","ingram","irvin","irvine","irving","irwin","ivers","jack","jackson","jacobs","jacobson","james","jameson","jamison","janson","jardine","jarrett","jarvis","jefferson","jeffries","jekyll","jenkins","jepson","jerome","jinks","johns","johnson","jones","jordan","judd","kay","keen","kelsey","kemp","kendall","kendrick","kerry","kersey","key","kidd","king","kingsley","kingston","kinsley","kipling","kirby","knight","lacy","lamar","landon","lane","langley","larson","lawson","leach","leavitt","lee","leigh","leon","levitt","lewin","lincoln","lindsay","linton","little","loman","london","long","lovell","lowell","lowry","lucas","lyndon","lynn","lyon","madison","mann","mark","marley","marlow","marshall","martel","martin","mason","massey","masters","masterson","mathers","matthews","may","mayes","maynard","meadows","mercer","merchant","merrill","merritt","michael","michaels","michaelson","mills","mitchell","moore","morris","myers","nathanson","neville","newell","newman","newport","nichols","nicholson","nielson","niles","nixon","noel","norman","oakley","odell","ogden","oliver","oliverson","olson","osborne","otis","overton","page","parker","parsons","patrick","patton","paulson","payne","pearce","pearson","penny","perkins","perry","peters","peyton","philips","pickering","pierce","pierson","piper","pitts","platt","poole","pope","porcher","porter","potter","pound","powers","prescott","pressley","preston","pryor","purcell","putnam","quigley","quincy","radcliff","raines","ramsey","randall","ray","reed","reeve","rey","reynolds","rhodes","richards","rider","ridley","roach","robbins","robert","roberts","robertson","rogers","rogerson","rollins","roscoe","ross","rowe","rowland","royce","roydon","rush","russell","ryder","sadler","salvage","sampson","samson","samuel","sanders","sandford","sanford","sargent","savage","sawyer","scarlett","seaver","sergeant","shelby","shine","simmons","simon","simons","simonson","simpkin","simpson","sims","sinclair","skinner","slater","smalls","smedley","smith","snelling","snider","sniders","snyder","spalding","sparks","spear","spears","spence","spencer","spooner","spurling","stacy","stafford","stamp","stanton","statham","steed","steele","stephens","stephenson","stern","stone","strange","strickland","stringer","stroud","strudwick","styles","summerfield","summers","sumner","sutton","sydney","tailor","tanner","tash","tasker","tate","taylor","teel","tennyson","terrell","terry","thacker","thatcher","thomas","thompson","thorne","thorpe","timberlake","townsend","tracy","travers","travis","trent","trevis","truman","tucker","tuft","turnbull","turner","tyler","tyrell","tyson","underhill","underwood","upton","vance","vernon","victor","vincent","walker","wallace","walsh","walton","warner","warren","warwick","washington","waters","wayne","weaver","webb","webster","wells","wembley","west","wheeler","whitaker","white","whitney","whittle","wickham","wilcox","wilkie","wilkins","willard","williams","williamson","willis","wilson","winchester","winfield","winship","winslow","winston","winthrop","witherspoon","wolf","wolfe","womack","woodcock","woodham","woodward","wortham","wray","wright","wyatt","wyndham","yates","york","young"};
        Color red = new Color(1f, 0.5f, 0.5f); Color green = new Color(0.5f, 1f, 0.5f); Color blue = new Color(0.6f, 0.6f, 1f); Color purple = new Color(0.9f, 0.45f, 0.9f); Color yellow = new Color(0.9f, 0.9f, 0.5f);
        public override void Init(){
            try{
              if (SuperController.singleton.editModeToggle.isOn == false)
                SuperController.singleton.editModeToggle.isOn = true;
              DAZCharacterSelector character_c = GetCharacter();
              if (character_c == null){
                  SuperController.LogError("This plugin can only be used on Person atoms.");
                  return;
              }
              lastSelected = containingAtom.mainController;
              newRandomSeed();
              SuperController.singleton.PauseSimulation(15, "Loading Menu");
              clearButtons();
              SuperController.singleton.PauseSimulation(15, "Loading Menu");
              int iter = 0;
              foreach (string hair in femaleHairChoices){
                femaleHairsDict[hair] = femaleHairs[iter];
                iter++;
              }
              iter = 0;
              foreach (string hair in maleHairChoices){
                maleHairsDict[hair] = maleHairs[iter];
                iter++;
              }
              UIDynamicButton baseMorphsButton = CreateButton("Add base morphs", false);
              baseMorphsButton.button.onClick.AddListener(delegate (){baseMorphs();});
              UIDynamicButton  addTG2 = CreateButton("Add TG2 morphs (+0.5)", false);
              addTG2.button.onClick.AddListener(delegate (){baseMorphs(true);});
              UIDynamicButton zeroMorphButton = CreateButton("Every morph to zero", false);
              zeroMorphButton.button.onClick.AddListener(delegate (){ZeroMorphs();});
              UIDynamicButton zeroExpressionButton = CreateButton("Every expression to zero", false);
              zeroExpressionButton.button.onClick.AddListener(delegate (){ZeroMorphs(true);});
              CreateSpacer().height = 10f;
              morphDivider = new JSONStorableFloat("Multiply morph values by", 1f, 0f, 2f, true);
              morphDivider.storeType = JSONStorableParam.StoreType.Full; CreateSlider(morphDivider, false);
              regionChoices = new JSONStorableStringChooser("Limit to region", getRegions(), "All", "Limit plugin to region");
      				RegisterStringChooser(regionChoices);
      				CreateScrollablePopup(regionChoices, false).popupPanelHeight = 680f;;
              UIDynamicButton  divideButton = CreateButton("Multiply morphs", false);
              divideButton.button.onClick.AddListener(delegate (){minusPlusMorph(0,false,false,true);});
              UIDynamicButton addSaveOneButton = CreateButton("Add save 1 * multiplier", false); addSaveOneButton.buttonColor = green;
              addSaveOneButton.button.onClick.AddListener(delegate (){addMorphs(morphDict);});
              UIDynamicButton addSaveTwoButton = CreateButton("Add save 2 * multiplier", false); addSaveTwoButton.buttonColor = green;
              addSaveTwoButton.button.onClick.AddListener(delegate (){addMorphs(morphDict2);});
              UIDynamicButton addSaveThreeButton = CreateButton("Add save 3 * multiplier", false); addSaveThreeButton.buttonColor = green;
              addSaveThreeButton.button.onClick.AddListener(delegate (){addMorphs(morphDict3);});
              UIDynamicButton removeSaveOneButton = CreateButton("Substract save 1 * multiplier", false); removeSaveOneButton.buttonColor = red;
              removeSaveOneButton.button.onClick.AddListener(delegate (){addMorphs(morphDict, true);});
              UIDynamicButton removeSaveTwoButton = CreateButton("Substract save 2 * multiplier", false); removeSaveTwoButton.buttonColor = red;
              removeSaveTwoButton.button.onClick.AddListener(delegate (){addMorphs(morphDict2, true);});
              UIDynamicButton removeSaveThreeButton = CreateButton("Substract save 3 * multiplier", false); removeSaveThreeButton.buttonColor = red;
              removeSaveThreeButton.button.onClick.AddListener(delegate (){addMorphs(morphDict3, true);});
              CreateSpacer().height = 10f;
              randomSlider = new JSONStorableFloat("Randomization %", 30f, 0f, 100f, true);
              randomSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(randomSlider, false);
              proportionalRandomization = new JSONStorableBool("Proportional Randomization", true);
              RegisterBool(proportionalRandomization);
              CreateToggle((proportionalRandomization), false);
              UIDynamicButton  randomVariaButton = CreateButton("Randomize morphs from quicksave 1", false);
              randomVariaButton.button.onClick.AddListener(delegate (){minusPlusMorph(1f,false,true);});
              CreateSpacer().height = 10f;
              newDNAValueSlider = new JSONStorableFloat("New DNA max random value", 0.25f, 0f, 1f, true);
              newDNAValueSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(newDNAValueSlider, false);
              newDNAminValueSlider = new JSONStorableFloat("New DNA min random value", 0.05f, -1f, 1f, true);
              newDNAminValueSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(newDNAminValueSlider, false);
              newDNASlider = new JSONStorableFloat("Number of new DNA strands to add", 10f, 0f, 100f, true);
              newDNASlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(newDNASlider, false);
              newDNAMultiplierSlider = new JSONStorableFloat("New character DNA multiplier", 4f, 1f, 10f, true);
              newDNAMultiplierSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(newDNAMultiplierSlider, false);
              vanillaDNA = new JSONStorableBool("Use only vanilla morphs", false);
              RegisterBool(vanillaDNA);
              CreateToggle((vanillaDNA), false);
              UIDynamicButton  newDNAButton = CreateButton("Add new DNA", false);
              newDNAButton.button.onClick.AddListener(delegate (){generateDNA();});
              CreateSpacer().height = 10f;
              mixSlider = new JSONStorableFloat("Proportional mix quicksaves 1 and 2", 0.5f, 0f, 1f, true);
              mixSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(mixSlider, false);
              mixSlider.slider.onValueChanged.AddListener((float value) =>{
                saveLoadMorphs(false, mergeDict, false, false, true,true);
              });
              UIDynamicButton fiftyfiftyButton = CreateButton("Merge 50/50", false);
              fiftyfiftyButton.button.onClick.AddListener(delegate (){saveLoadMorphs(false, mergeDict, true, false, false);});
              UIDynamicButton fiftyfiftyPlusButton = CreateButton("Merge 50/50 + full unique values", false);
              fiftyfiftyPlusButton.button.onClick.AddListener(delegate (){saveLoadMorphs(false, mergeDict, true, false, true);});
              UIDynamicButton randomMixButton = CreateButton("Random merge", false);
              randomMixButton.button.onClick.AddListener(delegate (){saveLoadMorphs(false, mergeDict, true);});
              CreateSpacer().height = 10f;
              randomizeSkc = new JSONStorableBool("Randomize skin", false, (bool on)=>{
                randomizeSkc.val = false;
                randomStyle();
              });
              RegisterBool(randomizeSkc);
              mix1and2 = new JSONStorableBool("Mix 1 and 2", false, (bool on)=>{
                mix1and2.val = false;
                saveLoadMorphs(false, mergeDict, true);
              });
              RegisterBool(mix1and2);
              qksv1 = new JSONStorableBool("Quicksave 1", false, (bool on)=>{
                qksv1.val = false;
                saveLoadMorphs(true, morphDict, false);
              });
              RegisterBool(qksv1);
              qksv2 = new JSONStorableBool("Quicksave 2", false, (bool on)=>{
                qksv2.val = false;
                saveLoadMorphs(true, morphDict2, false);
              });
              RegisterBool(qksv2);
              CreateSpacer().height = 10f;
              UIDynamicButton  newCharacterButton = CreateButton("Random Character", true); newCharacterButton.buttonColor = blue;
              newCharacterButton.button.onClick.AddListener(delegate (){
                ZeroMorphs();
                generateDNA(true);SuperController.singleton.PauseSimulation(5, "Loading");
                randomStyle();SuperController.singleton.PauseSimulation(5, "Loading");
                baseMorphs();SuperController.singleton.PauseSimulation(5, "Loading");
                });
              UIDynamicButton randomStyleButton = CreateButton("Random style", true);  randomStyleButton.buttonColor = yellow;
              randomStyleButton.button.onClick.AddListener(delegate (){randomStyle();});
              allowRandomSkin = new JSONStorableBool("Random skin", true);
              RegisterBool(allowRandomSkin);
              CreateToggle((allowRandomSkin), true);
              allowRandomHair = new JSONStorableBool("Random hairs", true);
              RegisterBool(allowRandomHair);
              CreateToggle((allowRandomHair), true);
              allowRandomEyes = new JSONStorableBool("Random eyes", true);
              RegisterBool(allowRandomEyes);
              CreateToggle((allowRandomEyes), true);
              randomName = new JSONStorableBool("Random name", true);
              RegisterBool(randomName);
              CreateToggle((randomName), true);
              randomScale = new JSONStorableBool("Random scale", false);
              RegisterBool(randomScale);
              CreateToggle((randomScale), true);
              randomHairSimStyle = new JSONStorableBool("Change hair style", true);
              RegisterBool(randomHairSimStyle);
              CreateToggle((randomHairSimStyle), true);
              randomCurls = new JSONStorableBool("Random curls/lengths", randomCurlsEnabled);
              RegisterBool(randomCurls);
              CreateToggle((randomCurls), true);
              allowRandomHairColors = new JSONStorableBool("Random hair colors", true);
              RegisterBool(allowRandomHairColors);
              CreateToggle((allowRandomHairColors), true);
              rainbowHair = new JSONStorableBool("Rainbow hairs", false);
              RegisterBool(rainbowHair);
              CreateToggle((rainbowHair), true);
              rainbowEyes = new JSONStorableBool("Rainbow eyes", false);
              RegisterBool(rainbowEyes);
              CreateToggle((rainbowEyes), true);
              rainbowSkin = new JSONStorableBool("Rainbow skin", false);
              RegisterBool(rainbowSkin);
              CreateToggle((rainbowSkin), true);
              randomSkinTexture = new JSONStorableBool("Random skin texture", false);
              RegisterBool(randomSkinTexture);
              CreateToggle((randomSkinTexture), true);
              clearSkin = new JSONStorableBool("Clear skin", true);
              RegisterBool(clearSkin);
              CreateToggle((clearSkin), true);
              lowGPUhairs = new JSONStorableBool("Low GPU hairs preset", applyHairPreset);
              RegisterBool(lowGPUhairs);
              CreateToggle((lowGPUhairs), true);
              randomHairLengthSlider = new JSONStorableFloat("Hair length multiplier", 1f, 0f, 2f, true);
              randomHairLengthSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(randomHairLengthSlider, true);
              randomHairCurlSlider = new JSONStorableFloat("Hair curl multiplier", 1f, 0f, 2f, true);
              randomHairCurlSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(randomHairCurlSlider, true);
              minEyeSlider = new JSONStorableFloat("Random Iris choice min", 1f, 1f, 59f, true);
              minEyeSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(minEyeSlider, true);
              maxEyeSlider = new JSONStorableFloat("Random Iris choice max", 30f, 1f, 59f, true);
              maxEyeSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(maxEyeSlider, true);
              lookMode = GetContainingAtom().GetStorableByID("Eyes").GetStringChooserJSONParam("lookMode");
              CreateTextField(
                  new JSONStorableString("instructions",
                      "\nMenu settings :"
                      )).height = 10f;
              hideMenu = new JSONStorableBool("Hide menu", false);
              RegisterBool(hideMenu);
              CreateToggle((hideMenu), false);
              useShortcuts = new JSONStorableBool("Use Shortcuts", true);
              RegisterBool(useShortcuts);
              CreateToggle((useShortcuts), false);
              alphaSlider = new JSONStorableFloat("Alpha value", 0.5f, 0.01f, 1.0f, true);
              CreateSlider(alphaSlider, false);
              alphaSlider.slider.onValueChanged.AddListener((float value) => {toggleAlpha();});
              RegisterFloat(alphaSlider);
              defDistSlider = new JSONStorableFloat("Adaptation distance", defaultDistance, 0f, 2.0f, true);
              defDistSlider.storeType = JSONStorableParam.StoreType.Full;
              RegisterFloat(defDistSlider);
              hideDistSlider = new JSONStorableFloat("Hide distance", defaultHideDistance, 0f, 2.0f, true);
              hideDistSlider.storeType = JSONStorableParam.StoreType.Full;
              RegisterFloat(hideDistSlider);
              defPositionSlider = new JSONStorableFloat("Menu depth", defPosition, -6.0f, 6.0f, true);
              defPositionSlider.storeType = JSONStorableParam.StoreType.Full;
              RegisterFloat(defPositionSlider);
              defautHeight = new JSONStorableFloat("Menu height", heightByDef, -6.0f, 6.0f, true);
              defautHeight.storeType = JSONStorableParam.StoreType.Full;
              RegisterFloat(defautHeight);
              posAdjust = new JSONStorableFloat("Position adjustment", posAdjustDefault, -6.0f, 6.0f, true);
              posAdjust.storeType = JSONStorableParam.StoreType.Full;
              RegisterFloat(posAdjust);
              secondPanelShiftSlider = new JSONStorableFloat("Panels X shift", secondPanelShiftX, -3.0f, 3.0f, true);
              secondPanelShiftSlider.storeType = JSONStorableParam.StoreType.Full;
              RegisterFloat(secondPanelShiftSlider);
              CreateSlider(defPositionSlider, false);
              CreateSlider(defautHeight, false);
              CreateSlider(defDistSlider, false);
              CreateSlider(hideDistSlider, false);
              CreateSlider(secondPanelShiftSlider, false);
              UIDynamicButton newRandomSeedButton = CreateButton("New random seed", false);
              newRandomSeedButton.button.onClick.AddListener(delegate (){newRandomSeed();});
              UIDynamicButton clearButtonsButton = CreateButton("Destroy every plugin button", false);
              clearButtonsButton.button.onClick.AddListener(delegate (){clearButtons();});
              UIDynamicButton ListMorphButton = CreateButton("List used morphs", true);
              ListMorphButton.button.onClick.AddListener(delegate (){minusPlusMorph(1f,true);});
              morphList = new JSONStorableString("FooString","");
              UIDynamic morphListText = CreateTextField(morphList,true);
              morphListText.height = 770;
              CreateTextField(new JSONStorableString("instructions","\nMisc options :"),true).height = 10f;
              hairSlider = new JSONStorableFloat("Hair Width", width, 0.00000f, 0.00100f, true);
              hairSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(hairSlider, true);
              hairSlider.slider.onValueChanged.AddListener((float value) =>{
                changeHairFloatParam("width",hairSlider.val);
                hairWidthLabel();
              });
              hairWidth = new JSONStorableString("FooString","\n" +	hairSlider.val.ToString());
      				UIDynamic dtext = CreateTextField(hairWidth,true);
              dtext.height = 100f;
              CreateSpacer().height = 10f;
              jDriveSpringSlider = new JSONStorableFloat("Joint drive spings percent", 100f, 0f, 200f, true);
              jDriveSpringSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(jDriveSpringSlider, true);
              RegisterFloat(jDriveSpringSlider);
              jDriveSpringSlider.slider.onValueChanged.AddListener((float value) =>{
                FreeControllerV3[] jointControls = containingAtom.GetComponentsInChildren<FreeControllerV3>(true);
                foreach (var c in jointControls){
                  if (c.name != "control"){
                    FreeControllerV3 fcv3 = containingAtom.freeControllers.First(fc => fc.name == c.name);
                    fcv3.SetFloatParamValue("jointDriveSpring", fcv3.GetFloatJSONParam("jointDriveSpring").defaultVal * jDriveSpringSlider.val/100);
                  }
                }
              });
              jDriveDamperSlider = new JSONStorableFloat("Joint drive damper percent", 100f, 0f, 200f, true);
              jDriveDamperSlider.storeType = JSONStorableParam.StoreType.Full;
              CreateSlider(jDriveDamperSlider, true);
              RegisterFloat(jDriveDamperSlider);
              jDriveDamperSlider.slider.onValueChanged.AddListener((float value) =>{
                FreeControllerV3[] jointControls = containingAtom.GetComponentsInChildren<FreeControllerV3>(true);
                foreach (var c in jointControls){
                  if (c.name != "control"){
                    FreeControllerV3 fcv3 = containingAtom.freeControllers.First(fc => fc.name == c.name);
                    fcv3.SetFloatParamValue("jointDriveDamper", fcv3.GetFloatJSONParam("jointDriveDamper").defaultVal * jDriveSpringSlider.val/100);
                  }
                }
              });
              saveLoadMorphs(true, morphDict, false);saveLoadMorphs(true, morphDict2, false);saveLoadMorphs(true, morphDict3, false);
              CreateSpacer().height = 10f;
              getHairs();
              hairWidthLabel();
              StartCoroutine(Setup());
            }
            catch (Exception e){;}
        }
        protected List<string> getRegions(){
          List<string> regionList = new List<string>(); regionList.Add("All");
          GenerateDAZMorphsControlUI morphControl = returnMorphs();
          morphControl.GetMorphDisplayNames().ForEach((name) =>{
            string reg = morphControl.GetMorphByDisplayName(name).region;
            if (!regionList.Contains(reg) && !reg.Contains("Pose"))
              regionList.Add(reg);
            });
          return regionList;
        }
        void newRandomSeed(){
          UnityEngine.Random.seed = UnityEngine.Random.Range(1,100000); UnityEngine.Random.seed = UnityEngine.Random.Range(1,100000);}
        private void baseMorphs(bool TG = false){
          GenerateDAZMorphsControlUI morphControl = returnMorphs();
          morphControl.GetMorphByDisplayName("Iris Depth_DD").morphValue = 0.42f;
          morphControl.GetMorphByDisplayName("MCMZaharaNavel").morphValue = 1f;
          morphControl.GetMorphByDisplayName("Navel Depth").morphValue = 0.5f;
          morphControl.GetMorphByDisplayName("Nipples").morphValue = 0.86f;
          morphControl.GetMorphByDisplayName("Nipples Apply").morphValue = 0.22f;
          if (TG) morphControl.GetMorphByDisplayName("Genesis 2 Female Rig").morphValue += 0.5f;
        }
        private void ZeroMorphs(bool expressionsOnly = false){
            GenerateDAZMorphsControlUI morphControl = returnMorphs();
            morphControl.GetMorphDisplayNames().ForEach((name) =>{
              DAZMorph morph = morphControl.GetMorphByDisplayName(name);
              if (((expressionsOnly && morph.region.Contains("Pose Controls")) || !expressionsOnly) && name != "Penis Length" && isInRegion(morph))
              morph.morphValue = 0;
            });
        }
        protected string hairWidthLabel(){
          return hairWidth.val = "\nHair Width : " + hairSlider.val.ToString();
        }
        protected void morphListLabel(string fullmorphlist){
          morphList.val = fullmorphlist;
        }
        private void getHairs(){
          if (containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("hairSelection").val == "SimV2 Hair" || containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("hairSelection").val == "SimV2 Hair Male"){
            if (containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("characterSelection").val.StartsWith("Female")) {
              choiceName = femaleHairsDict[containingAtom.GetStorableByID("Sim2HairStyle").GetStringChooserJSONParam("choiceName").val];
              scalps = femaleScalps;
            }else{
              choiceName = maleHairsDict[containingAtom.GetStorableByID("Sim2HairMaleStyle").GetStringChooserJSONParam("choiceName").val];
              scalps = maleScalps;
            }
          }else{
            choiceName = "Messy";
            scalps = femaleScalps;
          }
        }
        private void changeHairFloatParam(string param, float value){
          getHairs();
          containingAtom.GetStorableByID(choiceName).SetFloatParamValue(param, value);
        }
        private void changeEyeTarget(){
          if (lookMode.val == "Player"){
            lookMode.val = "Target";
          }else{
            lookMode.val = "Player";
          }
        }
        public DAZCharacterSelector GetCharacter(){
            JSONStorable geometryStorable = containingAtom.GetStorableByID("geometry");
            if (geometryStorable != null){
                DAZCharacterSelector geometry = geometryStorable as DAZCharacterSelector;
                if (geometry != null){
                    return geometry;
                }
            }
            return null;
        }
        public void Undress(){
            DAZCharacterSelector character = GetCharacter();
            List<DAZClothingItem> clothes = character.clothingItems.ToList();
            int index_c = 0;
            int wearCount = 0;
            character.clothingItems.ToList().ForEach((wearing) =>{
                if (wearing.active == true)
                  wearCount++;
                index_c++;
            });
            if (wearCount > 0){
              index_c = 0;
              clothDict = new Dictionary<int, bool>();
              character.clothingItems.ToList().ForEach((wearing) =>{
                clothDict[index_c] = wearing.active;
                character.SetActiveClothingItem(clothes[index_c], active: false);
                index_c++;
                });
            }else{
              foreach (KeyValuePair<int, bool> entry in clothDict){
                character.SetActiveClothingItem(clothes[entry.Key], entry.Value);
              }
            }
        }
        private void generateDNA(bool newChar = false){
          GenerateDAZMorphsControlUI morphControl = returnMorphs(); int DNAtoAdd;
          if (newChar){
            DNAtoAdd = (int)Math.Ceiling(newDNASlider.val*newDNAMultiplierSlider.val);
          }else{
            DNAtoAdd = (int)Math.Ceiling(newDNASlider.val);
          }
          int morphCount = 0;
          Dictionary<int, string> DNADict  = new Dictionary<int, string>();
          morphControl.GetMorphDisplayNames().ForEach((name) =>{
            DAZMorph morph = morphControl.GetMorphByDisplayName(name);
            if ((morph.morphValue == 0 && !morph.region.Contains("Pose Controls") && !name.Contains("Anubis") && !name.Contains("DD") && !morph.region.Contains("Alien") && morph.region!="Custom_" && !morph.region.Contains("Expressions") && !morph.region.Contains("Reptilian") && !morph.region.Contains("Teeth_") && isInRegion(morph))  || (isInRegion(morph) && morph.region == regionChoices.val))
            {
              if ((vanillaDNA.val && !morph.region.Contains("_")) || !vanillaDNA.val){
                DNADict[morphCount] = name;
                morphCount++;
              }
            }
          });
          string DNAlist = "";
          for (int i = 0; i < DNAtoAdd; i++){
            int randomStrand = UnityEngine.Random.Range(0,morphCount);
            string newDNA = DNADict[randomStrand];
            float newDNAvalue = UnityEngine.Random.Range(newDNAminValueSlider.val,newDNAValueSlider.val);
            morphControl.GetMorphByDisplayName(newDNA).morphValue = newDNAvalue;
            DNAlist = DNAlist + "\nnew : "+newDNA+" = "+newDNAvalue.ToString();
          }
          SuperController.LogMessage(DNAlist);
          morphListLabel(DNAlist);
        }
        GenerateDAZMorphsControlUI returnMorphs() {
          JSONStorable geometry = containingAtom.GetStorableByID("geometry");
          DAZCharacterSelector character = geometry as DAZCharacterSelector;
          return character.morphsControlUI;
        }
        void saveLook(){SuperController.singleton.Save(String.Concat("Saves\\Person\\appearance\\Custom\\Autosave\\",containingAtom.uid, ".json"), containingAtom, true, true);}
        void saveScene(){SuperController.singleton.SaveSceneDialog();}
        void addMorphs(Dictionary<string, float> morphDictio, bool sub = false) {
          GenerateDAZMorphsControlUI morphControl = returnMorphs();
          morphControl.GetMorphDisplayNames().ForEach((name) =>{
            DAZMorph morph = morphControl.GetMorphByDisplayName(name);
            if (morphDictio[name] != 0 && (regionChoices.val == "All" || (regionChoices.val != "All" && morph.region == regionChoices.val))){
              if (!sub){
                morph.morphValue = morph.morphValue + morphDictio[name] * morphDivider.val;
              }else{
                morph.morphValue = morph.morphValue - morphDictio[name] * morphDivider.val;
              }
            }
          });
        }
        void addDictToCharacter(Dictionary<string, float> morphDictio, float divider){
          GenerateDAZMorphsControlUI morphControl = returnMorphs();
          foreach (KeyValuePair<string, float> entry in morphDictio){
            DAZMorph morph = morphControl.GetMorphByDisplayName(entry.Key);
            if (isInRegion(morph))
              morph.morphValue = morph.morphValue + entry.Value/divider;
          }
        }
        private void saveLoadMorphs(bool saveM, Dictionary<string, float> morphDictio, bool merge, bool random = true, bool cumulative = true, bool proportional = false){
          GenerateDAZMorphsControlUI morphControl = returnMorphs();
            if (proportional){
              foreach (KeyValuePair<string, float> entry in morphDict){
                mergeDict[entry.Key] = entry.Value * (1f-mixSlider.val);
              }
              foreach (KeyValuePair<string, float> entry in morphDict2){
                mergeDict[entry.Key] = mergeDict[entry.Key] + entry.Value * mixSlider.val;
              }
            }else{
              if (merge ==true){
                if (random){
                  foreach (KeyValuePair<string, float> entry in morphDict){
                    if (morphDict2.ContainsKey(entry.Key)){
                      mergeDict[entry.Key] = UnityEngine.Random.Range(entry.Value,morphDict2[entry.Key]);
                    }else{
                      mergeDict[entry.Key] = UnityEngine.Random.Range(entry.Value,0);
                    }
                  }
                  foreach (KeyValuePair<string, float> entry in morphDict2){
                    if (!mergeDict.ContainsKey(entry.Key)){
                      mergeDict[entry.Key] = UnityEngine.Random.Range(entry.Value,0);
                    }
                  }
                }else{
                  foreach (KeyValuePair<string, float> entry in morphDict){
                    mergeDict[entry.Key] = entry.Value;
                  }
                  foreach (KeyValuePair<string, float> entry in morphDict2){
                    if (mergeDict.ContainsKey(entry.Key)){
                      if (cumulative){
                        if (mergeDict[entry.Key] == 0 ){
                          mergeDict[entry.Key] = entry.Value;
                        }else{
                          mergeDict[entry.Key] = (entry.Value+mergeDict[entry.Key])/2f;
                        }
                      }else{
                          mergeDict[entry.Key] = (entry.Value+mergeDict[entry.Key])/2f;
                      }
                    }else{
                      if (cumulative){
                          mergeDict[entry.Key] = entry.Value;
                      }else{
                          mergeDict[entry.Key] = entry.Value/2f;
                      }
                    }
                  }
                }
              }
            }
            morphControl.GetMorphDisplayNames().ForEach((name) =>{
              DAZMorph morph = morphControl.GetMorphByDisplayName(name);
                if(saveM == true){
                  morphDictio[name] = morph.morphValue;
                }else if (isInRegion(morph)){
                  morph.morphValue = morphDictio[name];
                }
            });
            if(merge == false && saveM)
              SuperController.LogMessage("Morphs saved");
            mergeDict  = new Dictionary<string, float>();
        }
        private void swap12(){
          morphDict4 = morphDict; morphDict = morphDict2; morphDict2 = morphDict4;
          SuperController.LogMessage("Quisaves swapped");
        }
        private void swap23(){
          morphDict4 = morphDict3; morphDict3 = morphDict2; morphDict2 = morphDict4;
          SuperController.LogMessage("Quisaves swapped");
        }
        bool isInRegion(DAZMorph morph){
          if (regionChoices.val == "All" || (regionChoices.val != "All" && morph.region == regionChoices.val))
            return true;
          return false;
        }

        private void minusPlusMorph(float val, bool listOnly, bool randomVaria = false, bool useSlider = false){
            GenerateDAZMorphsControlUI morphControl = returnMorphs();
            if (useSlider) val = morphDivider.val;
            string fullmorphlist = "";
            string fullmorphlistRegion = "";
            int    mCount        =  0;
            if (randomVaria) saveLoadMorphs(false, morphDict, false);
            morphControl.GetMorphDisplayNames().ForEach((name) =>{
                DAZMorph morph = morphControl.GetMorphByDisplayName(name);
                if (((morph.displayName != "Navel" && morph.displayName != "Nipples" && morph.displayName != "Penis Length" && morph.displayName != "Penis Width" && morph.morphValue != 0 && morph.region != "Genitalia_") && isInRegion(morph)) || (isInRegion(morph) && morph.region == regionChoices.val)) {
                  if (listOnly){
                    mCount++;
                    fullmorphlistRegion = fullmorphlistRegion + morph.region+"/"+name+" : "+morph.morphValue.ToString()+"\n";
                    fullmorphlist = fullmorphlist + name + " : " + morph.morphValue.ToString() + "\n";
                  }else{
                    if (randomVaria){
                      if (proportionalRandomization.val){
                        morph.morphValue = morph.morphValue*(UnityEngine.Random.Range(1f-randomSlider.val/100,1f+randomSlider.val/100));
                      }else{
                        morph.morphValue = UnityEngine.Random.Range(0,randomSlider.val/100);}
                    }else{morph.morphValue = morph.morphValue*val;}}}});
            if (listOnly){
              SuperController.singleton.ClearMessages();
              SuperController.LogMessage("\nUsed morphs : "+mCount.ToString());
              SuperController.LogMessage("\n"+fullmorphlistRegion);
              fullmorphlist = "\nUsed morphs ("+mCount.ToString()+") :\n\n"+fullmorphlist;
              morphListLabel(fullmorphlist);
              // SuperController.singleton.OpenMessageLogPanel();
            }
        }
        private void saveStyle( Dictionary<string, float> styleDict, Dictionary<string, HSVColor> colorDict){
          getHairs();
        }
        private float randomSquare(bool high = false){
          float darkness = UnityEngine.Random.value;
          darkness = darkness*darkness;
          if (high) return 1-darkness;
          return darkness;
        }
        private void randomStyle(){
          HSVColor randomColor        = new HSVColor();
          HSVColor randomSubS         = new HSVColor();
          HSVColor randomEyeColor     = new HSVColor();
          HSVColor randomSpecEyeColor = new HSVColor();
          HSVColor randomScleraColor  = new HSVColor();
          HSVColor randomHairColor    = new HSVColor();
          HSVColor randomHairTColor   = new HSVColor();
          HSVColor scalpColor         = new HSVColor();
          if (randomName.val){
            string lastName = lastNames[UnityEngine.Random.Range(0,lastNames.Length)];
            lastName = lastName.Substring(0, 1).ToUpper() + lastName.Substring(1);
            containingAtom.uid = femaleNames[UnityEngine.Random.Range(0,femaleNames.Length)]+" "+lastName;
          }
          if (randomScale.val){
            SuperController.singleton.PauseSimulation(20, "Loading for scale"); containingAtom.GetStorableByID("rescaleObject").SetFloatParamValue("scale",UnityEngine.Random.Range(0.9f,1.01f)); SuperController.singleton.PauseSimulation(20, "Loading for scale");
          }
          if (rainbowHair.val){
            randomHairColor.H = UnityEngine.Random.Range(0.2f,1f); randomHairColor.S = UnityEngine.Random.Range(0.78f,1f); randomHairColor.V = UnityEngine.Random.Range(0.4f,1f);
            randomHairTColor.H = randomHairColor.H-0.2f; randomHairTColor.S = randomHairColor.S-0.1f; randomHairTColor.V = UnityEngine.Random.Range(0.2f,0.6f);
          }else{
            randomHairColor.H = UnityEngine.Random.Range(0,0.14f); randomHairColor.S = randomSquare(true)*0.7f+0.2f; randomHairColor.V = randomSquare()*0.3f;
            randomHairTColor.H = randomHairColor.H; randomHairTColor.S = randomHairColor.S+UnityEngine.Random.Range(-0.1f,0.1f); randomHairTColor.V = randomSquare()*0.42f;
          }
          if (rainbowSkin.val){
            randomColor.H = UnityEngine.Random.Range(0,1f); randomColor.S = UnityEngine.Random.Range(0.3f,1f); randomColor.V = UnityEngine.Random.Range(0.6f,1f);
          }else if (clearSkin.val){
            randomColor.H = UnityEngine.Random.Range(0,0.076f); randomColor.S = randomSquare()*0.23f; randomColor.V = randomSquare(true)*0.24f+0.76f;
          }else{
            randomColor.H = UnityEngine.Random.Range(0,0.09f); randomColor.S = UnityEngine.Random.Range(0,0.5f); randomColor.V = UnityEngine.Random.Range(0.36f,1f);
          }
          scalpColor.H =  randomHairColor.H; scalpColor.S = randomHairColor.S; scalpColor.V = randomHairColor.V+0.22f;
          randomSubS.H = UnityEngine.Random.Range(0,0.1f); randomSubS.S = UnityEngine.Random.Range(0,0.3f); randomSubS.V = UnityEngine.Random.Range(0.7f,1f);
          if (rainbowEyes.val){
            randomEyeColor.H = UnityEngine.Random.Range(0,1f); randomEyeColor.S = UnityEngine.Random.Range(0.6f,1f); randomEyeColor.V = UnityEngine.Random.Range(0.7f,1f);
            randomSpecEyeColor.H = randomEyeColor.H ; randomSpecEyeColor.S = UnityEngine.Random.Range(0.8f,1f); randomSpecEyeColor.V = UnityEngine.Random.Range(0.9f,1f);
          }else{
            randomEyeColor.H = UnityEngine.Random.Range(0,0.55f); randomEyeColor.S = UnityEngine.Random.Range(0f,1f); randomEyeColor.V = UnityEngine.Random.Range(0.6f,1f);
            randomSpecEyeColor.H = 0f; randomSpecEyeColor.S = 0f; randomSpecEyeColor.V = 1f;
          }
          randomScleraColor.H = UnityEngine.Random.Range(0,0.03f); randomScleraColor.S = UnityEngine.Random.Range(0f,0.12f); randomScleraColor.V = UnityEngine.Random.Range(0.95f,1f);
          if (allowRandomSkin.val){
            if (randomSkinTexture.val && containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("characterSelection").val.StartsWith("Female")) containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("characterSelection").val = femaleSkinsForRandomStyle[UnityEngine.Random.Range(0,femaleSkinsForRandomStyle.Length)];
            containingAtom.GetStorableByID("skin").SetColorParamValue("Skin Color", randomColor);
            containingAtom.GetStorableByID("skin").SetColorParamValue("Subsurface Color", randomSubS);
            containingAtom.GetStorableByID("skin").GetFloatJSONParam("Gloss").val = randomSquare()*2.6f+4f;
            containingAtom.GetStorableByID("skin").GetFloatJSONParam("Specular Intensity").val = randomSquare()*1.4f+0.4f;
            containingAtom.GetStorableByID("skin").GetFloatJSONParam("Specular Fresnel").val = randomSquare(true)*0.32f+0.68f;
          }
          if (allowRandomEyes.val){
            containingAtom.GetStorableByID("irises").SetColorParamValue("Eye Color", randomEyeColor);
            containingAtom.GetStorableByID("irises").SetColorParamValue("Specular Eye Color", randomSpecEyeColor);
            containingAtom.GetStorableByID("sclera").SetColorParamValue("Sclera Color", randomScleraColor);
            containingAtom.GetStorableByID("irises").SetFloatParamValue("Iris Specular Intensity", UnityEngine.Random.Range(0.8f,1.4f));
            containingAtom.GetStorableByID("irises").GetStringChooserJSONParam("Irises").val = "Color "+ UnityEngine.Random.Range((int)Math.Ceiling(minEyeSlider.val),(int)Math.Ceiling(maxEyeSlider.val));
          }
          if (allowRandomHair.val){
            if (randomHairSimStyle.val && containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("characterSelection").val.StartsWith("Female"))
              containingAtom.GetStorableByID("Sim2HairStyle").GetStringChooserJSONParam("choiceName").val = femaleHairsForRandomStyle[UnityEngine.Random.Range(0,femaleHairsForRandomStyle.Length)];
            getHairs();
            float primarySpecularSharpness   = UnityEngine.Random.Range(2f,256f);
            float secondarySpecularSharpness = UnityEngine.Random.Range(2f,256f);
            float specularShift              = UnityEngine.Random.Range(0,1f);
            float fresnelPower               = UnityEngine.Random.Range(0f,10f);
            float fresnelAttenuation         = UnityEngine.Random.Range(0f,1f);
            float diffuseSoftness            = UnityEngine.Random.Range(0f,1f);
            float randomColorPower           = UnityEngine.Random.Range(0.5f,1.5f);
            if (allowRandomHairColors.val){
              foreach (string scalp in scalps)
                containingAtom.GetStorableByID(scalp).SetColorParamValue("Diffuse Color", scalpColor);
              containingAtom.GetStorableByID(choiceName).SetColorParamValue("rootColor", randomHairColor);
              containingAtom.GetStorableByID(choiceName).SetColorParamValue("tipColor", randomHairTColor);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("primarySpecularSharpness", primarySpecularSharpness);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("secondarySpecularSharpness"  , secondarySpecularSharpness);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("specularShift", specularShift);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("fresnelPower", fresnelPower);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("fresnelAttenuation", fresnelAttenuation);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("diffuseSoftness", diffuseSoftness);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("randomColorPower", randomColorPower);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("colorRolloff", UnityEngine.Random.Range(0.1f,1.5f));
            }
            if (randomCurls.val){
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("curlX",         UnityEngine.Random.Range(0f,1f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("curlY",         UnityEngine.Random.Range(0f,1f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("curlZ",         UnityEngine.Random.Range(0f,1f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("curlScale",     UnityEngine.Random.Range(0.01f,0.08f)*randomHairCurlSlider.val);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("curlFrequency", UnityEngine.Random.Range(2f,10f)*randomHairCurlSlider.val);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("length1", UnityEngine.Random.Range(0.3f,1f)*randomHairLengthSlider.val);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("length2", UnityEngine.Random.Range(0.3f,1f)*randomHairLengthSlider.val);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("length3", UnityEngine.Random.Range(0.3f,1f)*randomHairLengthSlider.val);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("collisionRadius", UnityEngine.Random.Range(0.001f,0.01f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("gravityMultiplier", UnityEngine.Random.Range(0.7f,1.1f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("weight", UnityEngine.Random.Range(0.8f,1.6f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("rootRigidity", UnityEngine.Random.Range(0.05f,0.15f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("mainRigidity", UnityEngine.Random.Range(0.005f,0.014f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("cling", UnityEngine.Random.Range(0.4f,0.6f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("clingRolloff", UnityEngine.Random.Range(0.8f,1f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("rigidityRolloffPower", UnityEngine.Random.Range(2f,12f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("snap", UnityEngine.Random.Range(0.15f,0.25f));
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("bendResistance", UnityEngine.Random.Range(0.1f,0.3f));
            }
            if (lowGPUhairs.val){
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("width", hairSlider.val);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("friction", friction);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("iterations", iterations);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("curveDensity", curveDensity);
              containingAtom.GetStorableByID(choiceName).SetFloatParamValue("hairMultiplier", hairMultiplier);
              containingAtom.GetStorableByID(choiceName).GetStringChooserJSONParam("shaderType").val = "Fast";
            }
          }
        }
        void showHUD(){SuperController.singleton.ShowMainHUDAuto();}

        void selectMain(){
          showHUD();
          FreeControllerV3 selected = SuperController.singleton.GetSelectedController();
          if (selected != containingAtom.mainController){
            lastSelected = selected;
            SuperController.singleton.SelectController(containingAtom.mainController);
          }else{
            SuperController.singleton.SelectController(lastSelected);
          }
        }
        void loadLook(){
          showHUD();
          SuperController.singleton.SelectController(containingAtom.mainController);
          containingAtom.LoadAppearancePresetDialog();
        }
        void loadPose(){
          showHUD();
          SuperController.singleton.SelectController(containingAtom.mainController);
          containingAtom.LoadPhysicalPresetDialog();
        }
        IEnumerator Setup(){
            yield return new WaitForSeconds(1.0f);
            CreateWorldButton("Select Main", () =>{
                selectMain();
            });
            CreateWorldButton("Load Look", () =>{
                loadLook();
            });
            CreateWorldButton("Load Pose", () =>{
                loadPose();
            });
            CreateWorldButton("Save Look", () =>{
                saveLook();
            });
            CreateWorldButton("Save Scene", () =>{
                saveScene();
            });
            CreateWorldButton("Look target", () =>{
                changeEyeTarget();
            },0.77f);
            CreateWorldButton("Undress / Dress", () =>{
                Undress();
            },0.77f);
            CreateWorldButton("Fix sim hairs position", () =>{
                resetHairs();
            },0.77f);
            CreateWorldButton("Random Style", () =>{
                randomStyle();
            },0.4f);
            CreateWorldButton("Random character", () =>{
               ZeroMorphs();
               generateDNA(true);SuperController.singleton.PauseSimulation(5, "Loading");
               randomStyle();SuperController.singleton.PauseSimulation(5, "Loading");
               baseMorphs();SuperController.singleton.PauseSimulation(5, "Loading");
            },0.4f);
            CreateWorldButton("New morph set", () =>{
               ZeroMorphs();
               generateDNA(true);SuperController.singleton.PauseSimulation(5, "Loading");
               baseMorphs();SuperController.singleton.PauseSimulation(5, "Loading");
            },0.4f);
            CreateWorldButton("Add new DNA", () =>{
                generateDNA();
            },0.4f);
            CreateWorldButton("Add base morphs", () =>{
                baseMorphs();
            },0.4f);
            CreateWorldButton("Reset expressions", () =>{
                ZeroMorphs(true);
            },0.95f);
            CreateWorldButton("Swap quisaves 1-2", () =>{
                swap12();
            });
            CreateWorldButton("Swap quisaves 2-3", () =>{
                swap23();
            });
            CreateWorldButton("Quicksave 1", () =>{
                saveLoadMorphs(true, morphDict, false);
            },0);
            CreateWorldButton("Quicksave 2", () =>{
                saveLoadMorphs(true, morphDict2, false);
            },0);
            CreateWorldButton("Quicksave 3", () =>{
                saveLoadMorphs(true, morphDict3, false);
            },0);
            CreateWorldButton("Quickload 1", () =>{
                saveLoadMorphs(false, morphDict, false);
                baseMorphs();
            },0.33f);
            CreateWorldButton("Quickload 2", () =>{
                saveLoadMorphs(false, morphDict2, false);
                baseMorphs();
            },0.33f);
            CreateWorldButton("Quickload 3", () =>{
                saveLoadMorphs(false, morphDict3, false);
                baseMorphs();
            },0.33f);
            CreateWorldButton("Randomize from save 1", () =>{
                minusPlusMorph(1f,false,true);
                baseMorphs();
            });
            CreateWorldButton("Random mix 1 and 2", () =>{
                saveLoadMorphs(false, mergeDict, true);
                baseMorphs();
            });
            CreateWorldButton("50/50 1 and 2", () =>{
                saveLoadMorphs(false, mergeDict, true, false, false);
                baseMorphs();
            });
            CreateWorldButton("50/50+ 1 and 2", () =>{
                saveLoadMorphs(false, mergeDict, true, false, true);
                baseMorphs();
            });
            CreateWorldButton("Merge all quicksaves", () =>{
                ZeroMorphs();SuperController.singleton.PauseSimulation(5, "Loading");
                addDictToCharacter(morphDict,3);SuperController.singleton.PauseSimulation(5, "Loading");
                addDictToCharacter(morphDict2,3);SuperController.singleton.PauseSimulation(5, "Loading");
                addDictToCharacter(morphDict3,3);SuperController.singleton.PauseSimulation(5, "Loading");
                baseMorphs();SuperController.singleton.PauseSimulation(5, "Loading");
            });
            CreateWorldButton("Hide menu", () =>{
                hideMenu.val = !hideMenu.val;
            });
        }
        void CreateWorldButton(string buttonLabel, UnityEngine.Events.UnityAction call, float hcolor = 0.66f){
            StartCoroutine(CreateWorldButtonCO(buttonLabel, hcolor, call, buttonIndex++));
        }
        private bool alternateColor = false;
        IEnumerator CreateWorldButtonCO(string buttonLabel, float hcolor, UnityEngine.Events.UnityAction call, int index){
            Atom containingAtom = GetContainingAtom();
            string name = containingAtom.uid;
            string uid = "CtxMenuPlugin_"+ name + " " + buttonLabel;
            Atom atom = SuperController.singleton.GetAtomByUid(uid);
            if (atom == null){
                yield return SuperController.singleton.AddAtomByType("UIButton", uid);
            }else{
                Debug.Log("button already exists");
                if (buttons == null){
                    buttons = new List<Atom>();
                }
                buttons.Add(atom);
                yield return null;
            }
            atom = SuperController.singleton.GetAtomByUid(uid);
            atom.GetStorableByID("AtomControl").SetBoolParamValue("hidden", true);
            atom.GetStorableByID("Text").SetStringParamValue("text", buttonLabel);
            UIButtonTrigger ubt = atom.GetStorableByID("Trigger") as UIButtonTrigger;
            ubt.button.onClick.AddListener(call);
            atom.GetStorableByID("Canvas").SetFloatParamValue("xSize", 540);
            atom.GetStorableByID("Canvas").SetFloatParamValue("ySize", 80);
            HSVColor buttonBackground = new HSVColor();
            if (alternateColor && alternateButtonColors){
              alternateColor = false;
              buttonBackground.H = hcolor; buttonBackground.S = 0.5f; buttonBackground.V = .21f;
            }else{
              alternateColor = true;
              buttonBackground.H = hcolor; buttonBackground.S = 0.5f; buttonBackground.V = .18f;}
            HSVColor gray = new HSVColor();
            gray.H = 0; gray.S = 0; gray.V = 0.75f;
            atom.GetStorableByID("TextColor").SetColorParamValue("color", gray);
            atom.GetStorableByID("ButtonColor").SetColorParamValue("color", buttonBackground);
            atom.GetStorableByID("Text").SetFloatParamValue("fontSize", 44);
            FreeControllerV3 controller = atom.GetStorableByID("control") as FreeControllerV3;
            controller.deselectedMeshScale = 0.000f;
            SphereCollider collider = controller.GetComponent<SphereCollider>();
            collider.radius = 0.0f;
            collider.enabled = false;
            atom.SetOn(false);
            buttons.Add(atom);
        }
        void RestorePosition(Atom atom, FreeControllerV3 controller, int index){
            if (atom == null || controller == null || hideMenu.val)
                return;
            Transform      pc = SuperController.singleton.lookCamera.transform;
            Vector3    camPos = pc.position;
            Quaternion camRot = pc.rotation;
            camRot[0] = 0;
            camRot[2] = 0;
            float translateY = 0;
            float translateX = -BUTTON_SPACINGX;
            if (index >= (buttonIndex/2) && !oneColumn){
              translateY = buttonIndex/2*BUTTON_SPACINGY;
              translateX = BUTTON_SPACINGX+secondPanelShiftSlider.val;
            }
            else{
              translateX = -BUTTON_SPACINGX-secondPanelShiftSlider.val;
            }
            Vector3 headPos = containingAtom.GetStorableByID("headControl").transform.position;
            Vector3 flatHead = new Vector3(headPos[0],0,headPos[2]);
            Vector3 flatCam  = new Vector3( camPos[0],0, camPos[2]);
            float translateZ = 0;
            float dist = Vector3.Distance(flatHead, flatCam);
            if (dist < hideDistSlider.val){
              hideMenuBcDist = true;
              return;
            }else{
              hideMenuBcDist = false;
              if (dist < defDistSlider.val){
                translateZ = (defDistSlider.val-dist)/3;
                translateY = translateY + translateZ;
                if (index >= (buttonIndex/2)){
                  translateX = translateX-translateZ;
                }else{
                  translateX = translateX+translateZ;
                }
              }
            }
            float headY = headPos[1];
            headPos[1] = headPos[1] - BUTTON_SPACINGY * index + BUTTON_SPACINGY * buttonIndex/4 + defautHeight.val;
            headPos[0] = (headPos[0] + containingAtom.mainController.transform.position.x) / 2;
            headPos[2] = (headPos[2] + containingAtom.mainController.transform.position.z) / 2;
            atom.mainController.transform.SetPositionAndRotation(headPos, camRot);
            atom.mainController.transform.Translate(translateX, translateY, translateZ + defPositionSlider.val, Space.Self);
            atom.mainController.transform.LookAt(pc);
            Quaternion panXYZ = atom.mainController.transform.rotation;
            panXYZ[0] = 0f;
            panXYZ[2] = 0f;
            atom.mainController.transform.rotation = panXYZ;
        }
        protected string clockTime(){return System.DateTime.Now.ToString("HH:mm");}
        bool lastVisibility = true;
        FreeControllerV3 lastController;
        void pluginRefresh(){
            try{
                bool visibilityState = SuperController.singleton.GetSelectedAtom() == containingAtom && !hideMenu.val && !hideMenuBcDist;
                  bool visChanged = false;
                  if (visibilityState != lastVisibility){
                      visChanged = true;
                      lastVisibility = visibilityState;
                  }
                  bool controlChanged = lastController != SuperController.singleton.GetSelectedController();
                  if (controlChanged){
                      lastController = SuperController.singleton.GetSelectedController();
                  }
                  int index = 0;
                  buttons.ForEach((button) =>{
                      button.containingAtom.SetOn(visibilityState);
                      if (visChanged || lastController){
                          RestorePosition(button, containingAtom.mainController, index);
                      }
                      index++;
                  });
            }
            catch (Exception e){
                SuperController.LogError("Exception caught: " + e);
            }
        }
        private void resetHairs(){
          containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("hairSelection").val = "No Hair";
          containingAtom.GetStorableByID("geometry").GetStringChooserJSONParam("hairSelection").val = "SimV2 Hair";
        }
        void FixedUpdate(){
          pluginRefresh();
        }
        private void shortcutHandler(){
          if (useShortcuts.val){
            if (Input.GetKeyDown("1")) randomStyle();
            if (Input.GetKeyDown("2")){
              ZeroMorphs();
              generateDNA(true);SuperController.singleton.PauseSimulation(5, "Loading");
              baseMorphs();SuperController.singleton.PauseSimulation(5, "Loading");}
            if (Input.GetKeyDown("3")){
              ZeroMorphs();
              generateDNA(true);SuperController.singleton.PauseSimulation(5, "Loading");
              baseMorphs();SuperController.singleton.PauseSimulation(5, "Loading");
              randomStyle();SuperController.singleton.PauseSimulation(5, "Loading");}
            if (Input.GetKeyDown("4")) allowRandomHair.val = !allowRandomHair.val;
            if (Input.GetKeyDown("5")) allowRandomSkin.val = !allowRandomSkin.val;
            if (Input.GetKeyDown("6")) allowRandomEyes.val = !allowRandomEyes.val;
            if (Input.GetKeyDown("space")) Undress();
            if (Input.GetKeyDown("[1]")) saveLoadMorphs(false, morphDict, false);
            if (Input.GetKeyDown("[2]")) saveLoadMorphs(false, morphDict2, false);
            if (Input.GetKeyDown("[3]")) saveLoadMorphs(false, morphDict3, false);
            if (Input.GetKeyDown("[4]")) saveLoadMorphs(true, morphDict, false);
            if (Input.GetKeyDown("[5]")) saveLoadMorphs(true, morphDict2, false);
            if (Input.GetKeyDown("[6]")) saveLoadMorphs(true, morphDict3, false);
            if (Input.GetKeyDown("[7]")) saveLoadMorphs(false, mergeDict, true, false, false);
            if (Input.GetKeyDown("[8]")) saveLoadMorphs(false, mergeDict, true, false, true);
            if (Input.GetKeyDown("[9]")) saveLoadMorphs(false, mergeDict, true);
            if (Input.GetKeyDown("[+]")){
              ZeroMorphs();SuperController.singleton.PauseSimulation(5, "Loading");
              addDictToCharacter(morphDict,3);SuperController.singleton.PauseSimulation(5, "Loading");
              addDictToCharacter(morphDict2,3);SuperController.singleton.PauseSimulation(5, "Loading");
              addDictToCharacter(morphDict3,3);SuperController.singleton.PauseSimulation(5, "Loading");
              baseMorphs();SuperController.singleton.PauseSimulation(5, "Loading");}
            if (Input.GetKeyDown("[/]")) swap12();
            if (Input.GetKeyDown("[*]")) swap23();
            if (Input.GetKeyDown("h")) hideMenu.val = !hideMenu.val;
            if (Input.GetKeyDown("g")) changeEyeTarget();
            if (Input.GetKeyDown("q")) selectMain();
            if (Input.GetKeyDown("e")) loadPose();
            if (Input.GetKeyDown("r")) loadLook();
            if (Input.GetKeyDown("c")) toggleAlpha();
            if (Input.GetKeyDown("y")) resetHairs();
            if (Input.GetKeyDown("v")) baseMorphs();
            if (Input.GetKeyDown("s") && Input.GetKey(KeyCode.LeftControl)) saveLook();
            if (Input.GetKeyDown("d") && Input.GetKey(KeyCode.LeftControl)) saveScene();
          }
        }
        void Update(){
          shortcutHandler();
        }
        void clearButtons(){
          List<string> pluginButtons = SuperController.singleton.GetAtoms()
              .Where(atom => atom.name.Contains("CtxMenuPlugin_"))
              .Select(atom => atom.name).ToList();
              foreach(string toRemove in pluginButtons){
                SuperController.singleton.RemoveAtom(GetAtomById(toRemove));
              }
        }
        void OnDestroy(){
            buttons.ForEach((button) =>{
                if (button != null){
                    SuperController.singleton.RemoveAtom(button);
                }
            });
        }
        void toggleAlpha(){
          buttons.ForEach((button) =>{
              if (button != null){
                float alpha = alphaSlider.val;
                float cAlpha = button.GetStorableByID("TextColor").GetFloatJSONParam("alpha").val;
                if (cAlpha == alpha) alpha = 1;
                button.GetStorableByID("TextColor").SetFloatParamValue("alpha", alpha);
                button.GetStorableByID("ButtonColor").SetFloatParamValue("alpha", alpha);
              }
          });
        }
        // Full lists, uncomment to unlock all of them, or use them to your tastes :
        // string[] femaleSkinsForRandomStyle = {"Female 1", "Female 2", "Female 3", "Female 4", "Female 5", "Female 6", "Female 7", "Female 8", "Female 9", "Female 10", "Female 11", "Female 12", "Female 13", "Female 14", "Female 15", "Female Custom"};
        // string[] femaleHairsForRandomStyle = {"Ponytail","Long+Straight","Long+StraightOpt","Long+Curls","Long+HalfShave","Medium+Bob","Medium+Straight+Bangs","Medium+Bangs+Heart","Medium+Bangs+Bob","Short+Bangs","Short+Wavy+Bangs","Short+Pixie","Short+Pixie+Bangs","Mohawk","Pixiehawk","Boyish","StraightFringe","SlickBack","Afro","Messy"};
        string[] femaleSkinsForRandomStyle = {"Female 1", "Female 2", "Female 3", "Female 4", "Female 5", "Female 7", "Female 8", "Female 9", "Female 10", "Female 11", "Female 13", "Female 14", "Female 15", "Female Custom"};
        string[] femaleHairsForRandomStyle = {"Long+Straight","Long+Curls","Long+HalfShave"};
        // Menu options
        private float defaultDistance      = 1f; // distance at which the menu height and distance will start shifting
        private float defaultHideDistance  = 0.66f;
        private float heightByDef          = -0.33f;
        private float defPosition          = 0f;
        private float posAdjustDefault     = -0.2f;
        private float secondPanelShiftX    = 0.05f;
        private bool oneColumn             = false;
        private bool alternateButtonColors = true;
        // hair preset options
        private bool  applyHairPreset    = true; // Put "false" here if you don't want the hair preset by default
        private bool  randomCurlsEnabled = true;
        private float width              = 0.00033f;
        private float curveDensity       = 24f;
        private float hairMultiplier     = 19f;
        private float friction           = 0.18f;
        private float iterations         = 1f;
    }
}
